package CompileZ;
import java.io.File;
import java.io.FileReader;
import java.util.Scanner;
import java.util.*;
/** 
 * Extract Z information from LaTeX file. 
 * @author  Slim KALLEL
 * @version 1.0 20-11-06
 */




public class ExtractZInformation 
{
	
		String Name;//file name
		
		String [][]TabComp;int nbC;//components & le nombre
		String [][]TabRelat;int nbR;//relations & le nombre
		 
		String [][]TabDomRan;int nbDR;//Domaine and Range & le nombre
		String [] QuantConst;int nbQC; //Quantifier Constraints & le nombre
		String [] SimpleConst; int nbSC;//Simple Constrains & le nombre
	
		String [][]TabInput;int nbI; // Input
		String [][]TabOutput;int nbO;//Output
		String []TabPre;int nbPre;// Precondition
		String []TabPost;int nbPost;//PostCondition
	
	
	  public ExtractZInformation(String n){
	  	
	  	Name=n;
		
		

	}

	
	/*
	 *
	 *Extract the informations from the style schema (Schema)
	 *
	 */
	
	 public void StyleSchema (String Schema){
		 
		 TabComp= new String[100][3]; nbC=0;//components & le nombre
			TabRelat= new String[100][3]; nbR=0;//relations & le nombre
			 
			TabDomRan= new String[100][4]; nbDR =0;//Domaine and Range & le nombre
			QuantConst= new String [100]; nbQC=0; //Quantifier Constraints & le nombre
			SimpleConst= new String [100];  nbSC=0;//Simple Constrains & le nombre
		 
		 
	// String lineSep = System.getProperty("line.separator");
	 String line="",CompRelat="";
	 
	 try{
	     
	     Scanner s = new Scanner(new FileReader(new File(Name)));
	     
	     while(s.hasNext()&& !(line.equals("\\begin{schema}{"+Schema+"}"))) {
	 		line = s.nextLine();
	     }
	     
	     
	     /*
	      *Extract the component and the relation defined in the style schema
	      */ 
	     while(s.hasNext() && !(CompRelat.equals("\\where"))) {   
	    
	    	if( (exist(CompRelat,"\\finset")) || (exist(CompRelat,"\\seq")) )
	    		{
	    			
	    			StringTokenizer st = new StringTokenizer(CompRelat);
					if(st.hasMoreTokens()){
						String comp = st.nextToken();
						TabComp[nbC][0]=CompRelat.substring(0, (comp.length()-1));
						TabComp[nbC][1] = st.nextToken();
						String type= st.nextToken();
						TabComp[nbC][2]=type.substring(0, (type.length()-2));
	    			}

	    			nbC++;
		
	    		}
	    		else if (exist(CompRelat,"\\rel"))
	    		{	
				StringTokenizer st = new StringTokenizer(CompRelat);
					if(st.hasMoreTokens()){
						String name = st.nextToken();
						TabRelat[nbR][0]=name.substring(0, name.length()-1);
						TabRelat[nbR][1] = st.nextToken();
						st.nextToken();
						String type2= st.nextToken();
						TabRelat[nbR][2]=type2.substring(0, type2.length()-2);	
					}			
					
					nbR++;		
	    		}
	   	    	CompRelat = s.nextLine();		
		}
		
		/*
		 *Extract first the quantifier constraints (\exist or \forall or \exist1),
		 *		  second the domaine and the range constraints
		 *        thirdly the simple constraints.
		 */
		CompRelat = s.nextLine();
		while(s.hasNext() && !(CompRelat.equals("\\end{schema}"))) {   	    
	    	if( (exist(CompRelat,"\\exist")) || (exist(CompRelat,"\\forall")) || (exist(CompRelat,"\\exist_1")))
	    	{
					QuantConst[nbQC]= CompRelat;
					nbQC++;
	    	}
	    	else if( (exist(CompRelat,"\\dom")) || (exist(CompRelat,"\\ran")) )
	    	{
					StringTokenizer st = new StringTokenizer(CompRelat);
					if(st.hasMoreTokens()){
						TabDomRan[nbDR][0]= st.nextToken();
						TabDomRan[nbDR][1] = st.nextToken();
						TabDomRan[nbDR][2] = st.nextToken();
						String type2= st.nextToken();
						TabDomRan[nbDR][3]=type2.substring(0, type2.length()-2);	
					}
					
					nbDR++;
	    	}
	    	else
	    	{
	    		CompRelat=CompRelat.substring(0,CompRelat.length()-2);
	    		SimpleConst[nbSC]= CompRelat;
	    		
					nbSC++;
	    	}
	    	CompRelat = s.nextLine(); 	
		}
			         
	 }catch(Exception e){
	     e.printStackTrace();
	     System.out.println("Exception : #### "+e);
	 }
			
	}
	

	/**
	 * Extract the informations from the Operation schema(schema)
	 */	
	public void OperationSchema (String schema)
	{
		
		TabInput = new String[100][2]; nbI=0; // Input
		TabOutput = new String[100][2]; nbO=0;//Output
		TabPre = new String[100]; nbPre=0;// Precondition
		TabPost = new String[100]; nbPost=0;//PostCondition
		
		
 		String line="",CompRelat="";
	try{
	   
	     Scanner s = new Scanner(new FileReader(new File(Name)));
	     
	     while(s.hasNext()&& !(line.equals("\\begin{schema}{"+schema+"}"))) {
	 		line = s.nextLine();
	     }
	     
	     /*
	      *Extract the input (?) and the output (!) declaration in the operation schema
	      */
	     
	     
	     while(s.hasNext() && !(CompRelat.equals("\\where"))) { 
	     if (!CompRelat.equals(""))
	     {
	     	StringTokenizer st = new StringTokenizer(CompRelat);
	    	String comp1= st.nextToken();
	    	comp1=comp1.substring(0,comp1.length()-1);
	    	int introg = comp1.indexOf("?");
	    	if (introg!=-1){
	    		TabInput[nbI][0]=comp1;
	    		
	    		String ty1=st.nextToken();
				TabInput[nbI][1]=ty1.substring(0, ty1.length()-2);
	    		nbI++;
	    	}
	    	StringTokenizer st1 = new StringTokenizer(CompRelat);
	    	String comp2= st1.nextToken();
	    	int exclamat = comp2.indexOf("!");
	    	
	    	if (exclamat!=-1){
	    		TabOutput[nbO][0]=comp2;
	    		
	    		String ty1=st1.nextToken();
				TabOutput[nbO][1]=ty1.substring(0, ty1.length()-2);
	    		nbO++;
	    	}		
	     }
	     CompRelat = s.nextLine();
	    }
	     CompRelat = s.nextLine(); 
	     
	     /*
	      *Extract the Pre- and Post- Conditions
	      */
	     
	     while(s.hasNext() && !(CompRelat.equals("\\end{schema}"))) {   
	    	StringTokenizer st = new StringTokenizer(CompRelat);
	    	String comp= st.nextToken();
	    	int prim = comp.indexOf("'");
	  	 	String ss=CompRelat.substring(0, CompRelat.length()-2);
	    	if (prim!=-1){
	    		TabPost[nbPost]= ss;
	    		nbPost++;
	    	}
	    	else{
	    		TabPre[nbPre]= ss;
	    		nbPre++;
	    	}
	     CompRelat = s.nextLine(); 
	     }
	     
	     }catch(Exception exp){
	     
	     System.out.println("Z specification Exception     "+ exp);
	     	}
	}



	/**
	 * Checks if a word (word) exist int a line (line)
	 * @param line
	 * @param word
	 * @return
	 */
	public boolean exist(String line, String word)
	{
		boolean exist=false;
		StringTokenizer st = new StringTokenizer(line);
		while ((st.hasMoreTokens()) && (!exist) ){
			if ((st.nextToken()).equals(word))
					exist=true;
		}	
		return exist;
	}
	

	/**
	 * 
	 * @param args
	 */
	public static void main (String args[])
	{
		
		ExtractZInformation Z = new ExtractZInformation("pms2.tex");
		//Z.StyleSchema("CollaborativeAuthoringSystem");
		//Z.OperationSchema("InsertWriter");
		
		String []r=Z.getInformation("Patient");
		for(int i=0;i<r.length;i++)
			System.out.println("*9*9*9"+r[i]);
				
	}	
	
	/*
	 *Return a table, Type of compotent and their varibles and their types
	 */
	/**
	 * 
	 * @param component
	 * @return
	 */
	public String[] getInformation(String Type){
		String TabReturn [] = new String [100]; int nbCons=0;
		String Tab []; String vide="", declar="";
	 try{
		 	Scanner s = new Scanner(new FileReader(new File(Name)));
		    while(s.hasNext()&& ((!(vide.equals("\\begin{schema}{"+Type+"}")))   )) {
		 		vide = s.nextLine();
		    }

		   declar = s.nextLine();
		   while(s.hasNext() && (( !(declar.equals("\\end{schema}"))   ) && ( !(declar.equals("\\where")))))   {  //|| 		   			
					int sp=declar.indexOf(" ");
					if(sp>(-1)){
					TabReturn[nbCons]=declar.substring(0,sp-1);
					nbCons++;
					TabReturn[nbCons]=declar.substring(sp+1,declar.length()-2);
					nbCons++;
					}
		    	declar = s.nextLine();
		    } 

	    }catch(Exception e){System.out.println("Exc"+e);}
			Tab = new String [nbCons];
		    for(int i=0; i<nbCons; i++){
		    	Tab[i]=TabReturn[i];
		    }
		return Tab;
	
		
	}
}

