package CompileZ;

import org.jdom.*; 
import org.jdom.input.DOMBuilder;
import java.io.*;

/**
 *  Translate the XML file generated from P3 to the pre post and markage in Java table.
 */ 

public class TransformPetriNets {
	
	String fileName;
	String [] AllTransisition;
	String path;
	public TransformPetriNets(String file,String path1){
		fileName=file;
		path=path1;
	}
	
	public static void main(String args[]){
		
		//TransformPetriNets tpn = new TransformPetriNets("example.xml");
		//tpn.readXML();
		
	}
	/**
	 * 
	 * @return
	 */
	public void readXML()
		{
		int nbplace=0, nbtransition=0,nbarc=0;
			try{
				DOMBuilder builder = new DOMBuilder();
				Document doc = builder.build(new File(fileName));
				Element pnml = doc.getRootElement();
				Element[] net = enfant(pnml);
				
				Element [] pta = enfant (net[0]); 
					for(int j=0;j<pta.length;j++){
						if(pta[j].getName().equals("place")){
							nbplace++;
						}
						if(pta[j].getName().equals("transition")){
							nbtransition++;
						}
						if(pta[j].getName().equals("arc")){
							nbarc++;	
						}
					}
					
					//Declaration
					String [][] PlaceTab =new String [nbplace][2];
					String [][] TransitionTab =new String [nbtransition][2];
					String [][] PreTab =new String [nbplace][nbtransition];
					String [][] PostTab =new String [nbplace][nbtransition];
					
					
					
					//initialisation
					for(int m=0;m<nbplace;m++){
						for(int n=0;n<nbtransition;n++){
							PreTab[m][n]="0";	
							PostTab[m][n]="0";
						}
					}

					//Places
					for(int j=0;j<pta.length;j++){
					if(pta[j].getName().equals("place")){
						String refPlace =pta[j].getAttributeValue("id");
						Element [] properties = enfant(pta[j]);
						Element initialMarking = properties[2];
						Element [] valuePlace = enfant(initialMarking);
						Element value = valuePlace[0];
						
						String nbjetons=value.getText();
						
					//	System.out.println("--> "+nbjetons+ " -- "+refPlace);
						PlaceTab[j][0]=nbjetons;
						PlaceTab[j][1]=refPlace;
						}	
					}
					
					//transitions
					int i=0;
					for(int j=0;j<pta.length;j++){				
					if(pta[j].getName().equals("transition")){
						String refTransition =pta[j].getAttributeValue("id");
						Element [] properties = enfant(pta[j]);
						Element name = properties[1];
						Element [] valueTansition = enfant(name);
						Element value = valueTansition[0];
						
						String nameTransition =value.getText();
						
						TransitionTab[i][0]=""+nameTransition;
						TransitionTab[i][1]=""+refTransition;
						i++;
						}
					}
					
					AllTransisition= new String[nbtransition];
					for(int n=0;n<nbtransition;n++){
						AllTransisition[n]=""+TransitionTab[n][0];
					}
					
					//Pre
					for(int j=0;j<pta.length;j++){
						for (int k=0;k<nbtransition;k++)
						{
							if((pta[j].getName().equals("arc"))){
								String target =pta[j].getAttributeValue("target");
								Element [] properties = enfant(pta[j]);
								Element inscription = properties[1];
								Element [] valueArc = enfant(inscription);
								Element value = valueArc[0];
								
								String poidArc =value.getText();
								
								if(target.equals(TransitionTab[k][1]))
								{							
									String source=pta[j].getAttributeValue("source");
									int np=numPlaceTransisition(PlaceTab,source);
									int nt=numPlaceTransisition(TransitionTab,target);
									PreTab[np][nt]=poidArc;
								}
							}
						}
						
						
					}				
					
					//Post
					for(int j=0;j<pta.length;j++){
						for (int k=0;k<nbplace;k++)
						{
							
							if((pta[j].getName().equals("arc"))){
								String target =pta[j].getAttributeValue("target");
								Element [] properties = enfant(pta[j]);
								Element inscription = properties[1];
								Element [] valueArc = enfant(inscription);
								Element value = valueArc[0];
								
								String poidArc =value.getText();
								
								if(target.equals(PlaceTab[k][1]))
								{							
									String source=pta[j].getAttributeValue("source");
									int nt=numPlaceTransisition(TransitionTab,source);
									int np=numPlaceTransisition(PlaceTab,target);				
									PostTab[np][nt]=poidArc;
									
								}
							}
						}
					}
					
					
					
					FileWriter StateWriter = new FileWriter(path+"\\PetriSystemState.java");
					StateWriter.write("\n class PetriSystemState{");
					StateWriter.write("\n \t static	int nbplace ="+ nbplace+";");
					StateWriter.write("\n \t static	int [][] Marking = new int [nbplace][100];");
					StateWriter.write("\n \t static boolean isUpdate =false;");
					for(int m=0;m<nbtransition;m++){
						StateWriter.write("\n \t static	int [][]"+ TransitionTab[m][0] +"=new int [nbplace][2];");
					}
					
					
					
					StateWriter.write("\n \n \t static int[] getPreConditon(int Tab[][]){");
					StateWriter.write("\n \t \t int []TableReturn = new int [nbplace];");
					StateWriter.write("\n \t \t for(int i=0;i<nbplace;i++){");
					StateWriter.write("\n \t \t TableReturn[i]=Tab[i][0];");
					StateWriter.write("\n \t \t }");
					StateWriter.write("\n \t \t return TableReturn;");
					StateWriter.write("\n \t }");
				 	
					StateWriter.write("\n \n \t static void  UpdateNewState(int Tab[][], int n){");
					StateWriter.write("\n \t \t for(int i=0;i<nbplace;i++){");
					StateWriter.write("\n \t \t  Marking[i][n]= Marking[i][n]-Tab[i][0]+Tab[i][1];");
					StateWriter.write("\n \t \t }");
					StateWriter.write("\n \t }");
					
					StateWriter.write("\n \n \t static boolean isTransisitionEnabled(int []Tab,int n){");
					StateWriter.write("\n \t \t boolean isEnabled=true;int i=0;");
					StateWriter.write("\n \t \t while(i<nbplace && isEnabled){");
					StateWriter.write("\n \t \t if(Tab[i]>Marking[i][n])");
					StateWriter.write("\n \t \t isEnabled=false;");
					StateWriter.write("\n \t \t i++;");
					StateWriter.write("\n \t \t }");
					StateWriter.write("\n \t \t return isEnabled;");
					StateWriter.write("\n \t }");
					 
				
					
					StateWriter.write("\n \t static void getState (){");
					StateWriter.write("\n \t \t for(int i=0;i<100;i++){");
					for(int m=0;m<nbplace;m++){		
						StateWriter.write("\n \t \t Marking ["+m+"][i] = "+PlaceTab[m][0]+";");
	
					}
					StateWriter.write("\n \t \t }");
					for(int m=0;m<nbtransition;m++){
						for (int k=0;k<nbplace;k++)
						{
							StateWriter.write("\n \t \t "+ TransitionTab[m][0]+"["+k+"]["+ 0+"] ="+ PreTab[k][m]+";");
							StateWriter.write("\n \t \t "+ TransitionTab[m][0]+"["+k+"]["+ 1+"] ="+ PostTab[k][m]+";" );
						}
					}
					StateWriter.write("\n \t \t isUpdate=true;");
					StateWriter.write("\n \t \t }");
					StateWriter.write("\n \t }");
					StateWriter.close();
					
					
					
				
			}
			catch(Exception ex){System.out.println("Exception ... " + ex );}
			
			
		}
	
	
	public int numPlaceTransisition (String [][]Tab, String p){
		int num=0,i=0;
		while ((i<Tab.length) && (!p.equals(Tab[i][1]))){
			i++;
		}
		num=i;
		return num;
	}
	
	public int numTransition (String [][]Tab, String t){
		int num=0,i=0;
		while ((i<Tab.length) && (!t.equals(Tab[i][1]))){
			i++;
		}
		num=i;
		return num;
	}
	
	Element[] enfant(Element e)
	{
		if (e.hasChildren())
		{
			java.util.List l=e.getChildren(); 
			Object fils_objet[]=l.toArray();  
			Element fils[]=new Element [fils_objet.length]; 
			for(int i=0;i<fils_objet.length;i++)
			{
				fils[i]=(Element)fils_objet[i];
			}
			return fils;
		}
		else return null;
	}
	
	
	
}
